#region Copyright Syncfusion Inc. 2001 - 2015
//
//  Copyright Syncfusion Inc. 2001 - 2015. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.ComponentModel;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Diagram.Controls;
using Syncfusion.Windows.Forms;
using System.Drawing;
using System.Drawing.Drawing2D;
using Syncfusion.Windows.Forms.Gauge;
using System.Runtime.Serialization;
using System.Collections;

namespace Syncfusion.Windows.Forms.Diagram.Samples
{
    /// <summary>
    /// Main application for CustomSymbol sample.
    /// </summary>
    public class MainForm : Form
    {
        #region Members

        private Panel panel1;
        private ToolStrip toolStrip1;
        private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram1;
        private Model model1;
        #endregion
        private PropertyGrid propertyGrid1;




        #region Form controls

        private IContainer components;
        #endregion

        #region Class Initialize/Finalize methods
        /// <summary>
        /// 
        /// </summary>
        public MainForm()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            this.diagram1.Model = this.model1;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="disposing"></param>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }


        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
            this.panel1 = new System.Windows.Forms.Panel();
            this.toolStrip1 = new System.Windows.Forms.ToolStrip();
            this.diagram1 = new Syncfusion.Windows.Forms.Diagram.Controls.Diagram(this.components);
            this.model1 = new Syncfusion.Windows.Forms.Diagram.Model(this.components);
            this.propertyGrid1 = new System.Windows.Forms.PropertyGrid();
            this.panel1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.diagram1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.model1)).BeginInit();
            this.SuspendLayout();
            // 
            // panel1
            // 
            this.panel1.Controls.Add(this.toolStrip1);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
            this.panel1.Location = new System.Drawing.Point(0, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(983, 25);
            this.panel1.TabIndex = 0;
            // 
            // toolStrip1
            // 
            this.toolStrip1.AutoSize = false;
            this.toolStrip1.BackColor = System.Drawing.SystemColors.Control;
            this.toolStrip1.BackgroundImageLayout = System.Windows.Forms.ImageLayout.None;
            this.toolStrip1.GripStyle = System.Windows.Forms.ToolStripGripStyle.Hidden;
            this.toolStrip1.Location = new System.Drawing.Point(0, 0);
            this.toolStrip1.Name = "toolStrip1";
            this.toolStrip1.Size = new System.Drawing.Size(983, 25);
            this.toolStrip1.TabIndex = 1;
            this.toolStrip1.Text = "toolStrip1";
            // 
            // diagram1
            // 
            this.diagram1.Controller.PasteOffset = new System.Drawing.SizeF(10F, 10F);
            this.diagram1.LayoutManager = null;
            this.diagram1.Location = new System.Drawing.Point(0, 25);
            this.diagram1.Model = this.model1;
            this.diagram1.Name = "diagram1";
            this.diagram1.ScrollVirtualBounds = ((System.Drawing.RectangleF)(resources.GetObject("diagram1.ScrollVirtualBounds")));
            this.diagram1.Size = new System.Drawing.Size(507, 416);
            this.diagram1.SmartSizeBox = false;
            this.diagram1.TabIndex = 2;
            this.diagram1.Text = "diagram1";
            // 
            // 
            // 
            this.diagram1.View.BackgroundColor = System.Drawing.Color.White;
            this.diagram1.View.ClientRectangle = new System.Drawing.Rectangle(0, 0, 0, 0);
            this.diagram1.View.Controller = this.diagram1.Controller;
            this.diagram1.View.Grid.MinPixelSpacing = 4F;
            this.diagram1.View.Grid.Visible = false;
            this.diagram1.View.ScrollVirtualBounds = ((System.Drawing.RectangleF)(resources.GetObject("resource.ScrollVirtualBounds")));
            this.diagram1.View.ZoomType = Syncfusion.Windows.Forms.Diagram.ZoomType.Center;
            // 
            // model1
            // 
            this.model1.BackgroundStyle.PathBrushStyle = Syncfusion.Windows.Forms.Diagram.PathGradientBrushStyle.RectangleCenter;
            this.model1.DocumentScale.DisplayName = "No Scale";
            this.model1.DocumentScale.Height = 1F;
            this.model1.DocumentScale.Width = 1F;
            this.model1.DocumentSize.Height = 1169F;
            this.model1.DocumentSize.Width = 827F;
            this.model1.LineStyle.DashPattern = null;
            this.model1.LineStyle.LineColor = System.Drawing.Color.Black;
            this.model1.LineStyle.LineWidth = 0F;
            this.model1.LogicalSize = new System.Drawing.SizeF(827F, 1169F);
            this.model1.ShadowStyle.Color = System.Drawing.Color.FromArgb(((int)(((byte)(128)))), ((int)(((byte)(105)))), ((int)(((byte)(105)))), ((int)(((byte)(105)))));
            this.model1.ShadowStyle.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(128)))), ((int)(((byte)(105)))), ((int)(((byte)(105)))), ((int)(((byte)(105)))));
            // 
            // propertyGrid1
            // 
            this.propertyGrid1.CategoryForeColor = System.Drawing.SystemColors.InactiveCaptionText;
            this.propertyGrid1.Dock = System.Windows.Forms.DockStyle.Right;
            this.propertyGrid1.Location = new System.Drawing.Point(691, 25);
            this.propertyGrid1.Name = "propertyGrid1";
            this.propertyGrid1.Size = new System.Drawing.Size(292, 591);
            this.propertyGrid1.TabIndex = 3;
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(6, 16);
            this.ClientSize = new System.Drawing.Size(983, 616);
            this.Controls.Add(this.propertyGrid1);
            this.Controls.Add(this.diagram1);
            this.Controls.Add(this.panel1);
            this.Font = new System.Drawing.Font("Segoe UI", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "MainForm";
            this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Custom Symbol";
            this.Load += new System.EventHandler(this.MainForm_Load);
            this.panel1.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.diagram1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.model1)).EndInit();
            this.ResumeLayout(false);

        }
        #endregion

        
        #endregion

        #region MAIN
        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new MainForm());
        }
        #endregion

        #region Event handlers
        private void MainForm_Load(object sender, EventArgs e)
        {
            DiagramAppearance();
            RadialGauge Rg = new RadialGauge();
            LinearGauge Lg = new LinearGauge();
            CustomControlNode RGControl = new CustomControlNode(Rg, new RectangleF(100, 100, 150, 150));
            RGControl.Name = "RadialGauge";
            CustomControlNode LGControl = new CustomControlNode(Lg, new RectangleF(200, 200, 150, 150));
            LGControl.Name = "LinearGauge";
            Rectangle rect = new Rectangle(100, 100, 100, 100);
            rect.Name = "Rectangle";
            PaletteGroupBar Pg = new PaletteGroupBar();
            Pg.Dock = DockStyle.Left;
            SymbolPalette Sym = new SymbolPalette();
            Sym.AppendChild(RGControl);
            Sym.AppendChild(LGControl);
            Sym.AppendChild(rect);
            Pg.AddPalette(Sym);
            diagram1.Controls.Add(Pg);
            diagram1.DragDrop += diagram1_DragDrop;
            diagram1.EventSink.SelectionListChanged += EventSink_SelectionListChanged;
            diagram1.EventSink.NodeCollectionChanged += EventSink_NodeCollectionChanged;
        }

        void EventSink_NodeCollectionChanged(CollectionExEventArgs evtArgs)
        {
            if (evtArgs.ChangeType == CollectionExChangeType.Insert)
            {
                if (evtArgs.Element is Node)
                {
                    Node node = evtArgs.Element as Node;
                    if (node.PropertyBag.Keys.Count == 0)
                    {
                        node.PropertyBag.Add("Name", node.Name);
                    }
                    if (node.PropertyBag.Keys.Count > 0)
                    {
                        CommonProperties properties = new CommonProperties();
                        properties.Name = node.PropertyBag["Name"].ToString();
                        propertyGrid1.SelectedObject = properties;
                    }
                }
            }
            else
            {
                propertyGrid1.SelectedObject = null;
            }
        }

        void EventSink_SelectionListChanged(CollectionExEventArgs evtArgs)
        {
            if (evtArgs.ChangeType == CollectionExChangeType.Insert)
            {
                if (evtArgs.Element is Node)
                {
                    Node node = evtArgs.Element as Node;
                    if (node.PropertyBag.Keys.Count > 0)
                    {
                        CommonProperties properties = new CommonProperties();
                        properties.Name = node.PropertyBag["Name"].ToString();
                        propertyGrid1.SelectedObject = properties;
                    }
                }
            }
            else
            {
                propertyGrid1.SelectedObject = null;
            }
        }

        void diagram1_DragDrop(object sender, DragEventArgs e)
        {
            IDataObject dataObj = e.Data;
            if (dataObj.GetDataPresent(typeof(DragDropData)))
            {
                DragDropData dragDropData = (DragDropData)dataObj.GetData(typeof(DragDropData));
                int count = dragDropData.Nodes.Count;
                if (count == 1)
                {
                    Node node = dragDropData.Nodes[0] as Node;
                    int nodecount = dragDropData.Nodes.Count;
                    if (nodecount==1)
                    {
                        node.PropertyBag.Add("Name",node.Name);
                    }
                }
            }
        }

        
        #endregion

        #region Private Methods
        /// <summary>
        /// change's the appearance of the diagram
        /// </summary>
        private void DiagramAppearance()
        {
            this.diagram1.View.Grid.Visible = false;
            this.diagram1.Dock = DockStyle.Fill;
            this.diagram1.Model.RenderingStyle.SmoothingMode = SmoothingMode.HighQuality;
            this.diagram1.View.SelectionList.Clear();
        }

        #endregion        
    }

    


}